--- Original PO/abrt.1-1-x.fr.po	2011-01-27 15:51:00.000000000 +1000
+++ Modified PO/abrt.1-1-x.fr.po	2011-01-27 16:37:55.000000000 +1000
@@ -1,17 +1,17 @@
-# translation of abrt.master.fr.po to French
+# translation of abrt.1-1-x.fr.po to French
 # Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
 # This file is distributed under the same license as the PACKAGE package.
 #
-# Sam Friedmann <sam.friedmann@redhat.com>, 2009, 2010.
+# Sam Friedmann <sam.friedmann@redhat.com>, 2009, 2010, 2011.
 # ratal <aymeric.rateau@gmail.com>, 2009, 2010.
 # Aymeric Rateau <aymeric.rateau@gmail.com>, 2010.
 # Thomas Canniot <mrtom@fedoraproject.org>, 2010.
 msgid ""
 msgstr ""
-"Project-Id-Version: abrt.master.fr\n"
+"Project-Id-Version: abrt.1-1-x.fr\n"
 "Report-Msgid-Bugs-To: jmoskovc@redhat.com\n"
 "POT-Creation-Date: 2011-01-27 05:40+0000\n"
-"PO-Revision-Date: 2010-08-04 11:39+1000\n"
+"PO-Revision-Date: 2011-01-27 16:37+1000\n"
 "Last-Translator: Sam Friedmann <sam.friedmann@redhat.com>\n"
 "Language-Team: French <French fedora-trans-fr@fedoraproject.org>\n"
 "MIME-Version: 1.0\n"
@@ -114,7 +114,7 @@
 #: ../lib/Plugins/CCpp.cpp:670
 #, c-format
 msgid "Backtrace parsing failed for %s"
-msgstr ""
+msgstr "Échec de l'analyse du parcours arrière pour %s"
 
@@ -208,16 +207,15 @@
 #. Gzipping e.g. 0.5gig coredump takes a while. Let client know what we are doing
 #: ../lib/Plugins/RHTSupport.cpp:106
 msgid "Compressing data"
-msgstr ""
+msgstr "Compression de données"
  
 #: ../lib/Plugins/RHTSupport.cpp:315
-#, fuzzy
 msgid "Reports bugs to Red Hat support"
-msgstr "Rapporte les bogues sur Bugzilla"
+msgstr "Rapporte les bogues au support Red Hat"
 
 #: ../lib/Plugins/RunApp.cpp:73
 msgid "Runs a command, saves its output"
@@ -363,7 +361,7 @@
 #: ../lib/Utils/abrt_curl.cpp:180
 #, c-format
 msgid "Uploaded: %llu of %llu kbytes"
-msgstr ""
+msgstr "Téléchargé : %llu sur %llu kilo-octets"
 

@@ -442,7 +439,7 @@
 msgstr "\tHostname   : %s\n"
 
 #: ../src/CLI/CLI.cpp:103
-#, fuzzy, c-format
+#, c-format
 msgid ""
 "Crash ID:           %s:%s\n"
 "Last crash:         %s\n"
@@ -462,19 +459,17 @@
 "Commande :            %s\n"
 "Exécutable :         %s\n"
 "Système :             %s, noyau %s\n"
-"Rating:             %s\n"
-"Fichier Coredump :      %s\n"
 "Raison :             %s\n"
 
 #: ../src/CLI/CLI.cpp:131
-#, fuzzy, c-format
+#, c-format
 msgid "Coredump file:      %s\n"
-msgstr "Fonction de l'incident :     %s\n"
+msgstr "Fichier Coredump :      %s\n"
 
 #: ../src/CLI/CLI.cpp:135
-#, fuzzy, c-format
+#, c-format
 msgid "Rating:             %s\n"
-msgstr "\tNom d'hôte   : %s\n"
+msgstr "Évaluation :             %s\n"
 

 #: ../src/CLI/report.cpp:424
 msgid ""
@@ -653,11 +647,11 @@
 #. The response might take more than 1 char in non-latin scripts.
 #: ../src/CLI/report.cpp:545
 msgid "y"
-msgstr ""
+msgstr "y"
 
 #: ../src/CLI/report.cpp:546
 msgid "N"
-msgstr ""
+msgstr "N"
  
 #: ../src/CLI/report.cpp:721
-#, fuzzy, c-format
+#, c-format
 msgid "Report using %s?"
-msgstr "Rapporter en utilisant %s ? [y/N] : "
+msgstr "Rapporter en utilisant %s ?"
 
 
 #: ../src/CLI/report.cpp:736
-#, fuzzy
 msgid "Reporting disabled because the backtrace is unusable"
-msgstr "L'envoi du rapport est désactivé car le backtrace est inutilisable."
+msgstr "L'envoi du rapport est désactivé car le backtrace est inutilisable"
 
 #: ../src/CLI/report.cpp:740
 #, c-format
@@ -697,11 +690,12 @@
 "Please try to install debuginfo manually using the command: \"debuginfo-"
 "install %s\" and try again\n"
 msgstr ""
+"Veuillez essayer d'installer debuginfo manuellement à l'aide de la commande : \"debuginfo-"
+"install %s\" puis essayez à nouveau\n"
 
 #: ../src/CLI/report.cpp:749
-#, fuzzy
 msgid "Error loading reporter settings"
-msgstr "Erreur lors de l'acquisition du rapport : %s"
+msgstr "Erreur lors du chargement des paramètres du rapporteur"
 
 #: ../src/Gui/ccgui.glade.h:12
 msgid "Online _Help"
-msgstr ""
+msgstr "_Aide en ligne"
 

 #: ../src/Gui/ConfBackend.py:79
-#, fuzzy
 msgid "Can't connect to gnome-keyring-daemon, changes won't be saved."
-msgstr "Connexion au démon Gnome Keyring impossible."
+msgstr "Connexion au démon gnome-keyring-daemon impossible, les changements ne seront pas enregistrés."
 
 
 #: ../src/Gui/CReporterAssistant.py:659
 msgid "You need to fill the how to before you can proceed..."
-msgstr ""
+msgstr "Vous devez remplir le « comment » avant de pouvoir continuer..."
 
 