diff --git a/virt_web/controllers/domain.py b/virt_web/controllers/domain.py
index 1900085..3b5b56e 100644
--- a/virt_web/controllers/domain.py
+++ b/virt_web/controllers/domain.py
@@ -107,7 +107,7 @@ class Domain(BaseController):
 
 #        nodes_dict = object_id_dict(nodes)
         tmpl_context.FILTER_DOMAIN_FORM = FILTER_DOMAIN_FORM
-        return dict(filter_name=filter_name, hostname='')
+        return dict(filter_name=filter_name, hostname='', tab="Guests")
 
     @expose('virt_web.templates.domain_edit')
     def edit(self, uuid):
diff --git a/virt_web/controllers/node.py b/virt_web/controllers/node.py
index 93a4c10..4209f37 100644
--- a/virt_web/controllers/node.py
+++ b/virt_web/controllers/node.py
@@ -61,7 +61,7 @@ class Node(BaseController):
     def list(self, filter_name='', submit=None):
         ''' Return a list of nodes '''
         tmpl_context.FILTER_NODE_FORM = FILTER_NODE_FORM
-        return dict(filter_name=filter_name)
+        return dict(filter_name=filter_name, tab="Hardware")
 
     @expose('virt_web.templates.node_view')
     def view(self, hostname):
diff --git a/virt_web/controllers/pool.py b/virt_web/controllers/pool.py
index b059659..98465c4 100644
--- a/virt_web/controllers/pool.py
+++ b/virt_web/controllers/pool.py
@@ -92,7 +92,7 @@ class Pool(BaseController):
 
         :arg filter_name: Filters the pools by hostname
         '''
-        return dict(filter_name=filter_name)
+        return dict(filter_name=filter_name, tab="Storage")
 
     @expose('virt_web.templates.pool_edit')
     def edit(self, uuid):
diff --git a/virt_web/controllers/root.py b/virt_web/controllers/root.py
index 42da873..c3b110a 100644
--- a/virt_web/controllers/root.py
+++ b/virt_web/controllers/root.py
@@ -82,7 +82,7 @@ class RootController(BaseController):
             else:
                 domains_offline += 1
         num_nodes = len(self.api.node_list()['items'])
-        return dict(domains_online=domains_online, domains_offline=domains_offline, num_nodes=num_nodes)
+        return dict(domains_online=domains_online, domains_offline=domains_offline, num_nodes=num_nodes, tab='Overview')
 
     @expose('virt_web.templates.authentication')
     def auth(self):
diff --git a/virt_web/controllers/template.py b/virt_web/controllers/template.py
index f0c5eb4..3be924b 100644
--- a/virt_web/controllers/template.py
+++ b/virt_web/controllers/template.py
@@ -94,7 +94,8 @@ class Template(BaseController):
                                         XmlTemplate.type=='volume').all()
         return dict(domain_templates=domain_templates,
                     pool_templates=pool_templates,
-                    volume_templates=volume_templates)
+                    volume_templates=volume_templates,
+                    tab="Templates")
 
     @expose('virt_web.templates.template_edit')
     def edit(self, template_name):
diff --git a/virt_web/templates/master.html b/virt_web/templates/master.html
index 8ff3f89..fbb6fce 100644
--- a/virt_web/templates/master.html
+++ b/virt_web/templates/master.html
@@ -18,11 +18,11 @@
 <body py:match="body" py:attrs="select('@*')">
   ${header()}
   <ul id="mainmenu">
-    <li class="first"><a href="${tg.url('/')}">Overview</a></li>
-    <li class=""><a href="${tg.url('/node/list')}">Hardware</a></li>
-    <li class=""><a href="${tg.url('/domain/list')}">Guests</a></li>
-    <li class=""><a href="${tg.url('/pool/list')}">Storage</a></li>
-    <li class=""><a href="${tg.url('/template/list')}">Templates</a></li>
+    <li class="first"><a href="${tg.url('/')}" class="${('', 'active')[defined('tab') and tab=='Overview']}">Overview</a></li>
+    <li class=""><a href="${tg.url('/node/list')}" class="${('', 'active')[defined('tab') and tab=='Hardware']}">Hardware</a></li>
+    <li class=""><a href="${tg.url('/domain/list')}" class="${('', 'active')[defined('tab') and tab=='Guests']}">Guests</a></li>
+    <li class=""><a href="${tg.url('/pool/list')}" class="${('', 'active')[defined('tab') and tab=='Storage']}">Storage</a></li>
+    <li class=""><a href="${tg.url('/template/list')}" class="${('', 'active')[defined('tab') and tab=='Templates']}">Templates</a></li>
 <!--    <li class=""><a href="${tg.url('/pool/list')}">Pools</a></li>
     <li class=""><a href="${tg.url('/volume/list')}">Volumes</a></li>-->
         <li><a href="${tg.url('/about')}" class="${('', 'active')[defined('page') and page==page=='about']}">About</a></li>