From b34631c987c2197d4933fa76e3b9043402b8b330 Mon Sep 17 00:00:00 2001
From: Eduardo Echeverria <echevemaster@gmail.com>
Date: Wed, 3 Sep 2014 21:59:34 -0430
Subject: [PATCH] I've added a map of the location and the university logo of
 the Fudcon Managua venue

---
 .../data/content/LATAM/location.html                    |   8 ++++++++
 .../static/images/logo_university.jpg                   | Bin 0 -> 30653 bytes
 2 files changed, 8 insertions(+)
 create mode 100644 fudcon.fedoraproject.org/static/images/logo_university.jpg

diff --git a/fudcon.fedoraproject.org/data/content/LATAM/location.html b/fudcon.fedoraproject.org/data/content/LATAM/location.html
index e99a164..23c8845 100644
--- a/fudcon.fedoraproject.org/data/content/LATAM/location.html
+++ b/fudcon.fedoraproject.org/data/content/LATAM/location.html
@@ -53,9 +53,17 @@
       <p>Managua is the Capital city of Nicaragua.</p>
       <p>One distinct feature is that has a lot of concrete cobbled streets. You can not walk the city, you may walk within some neighbourhood, but usually distances are beyond walking distance and there is lack of side walks.</p>
       <p>The address system is based on landmark references. You may think that Managua is a place "Where streets have no names", but in true is that nobody uses them.</p>
+           <div>
+               <h2>Map of the location</h2>
+               <iframe src="http://www.openstreetmap.org/export/embed.html?bbox=-86.26037836074829%2C12.115697637967443%2C-86.23892068862914%2C12.130550865538577&amp;layer=mapnik&amp;marker=12.123124355141126%2C-86.24964952468872" style="border: 1px solid black; display: block; margin: 0 auto;" height="360" width="600"></iframe><small><a class="f-link" href="http://www.openstreetmap.org/?mlat=12.1231&amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;mlon=-86.2496#map=16/12.1231/-86.2496">View Larger Map</a></small>
+           </div>
       <br />
       <h3>Venue</h3>
       <p>The venue is Universidad de Ciencias Comerciales this is a small university, every building is easy to finger point. Their conference hall is mid size, they have a second conference hall and some small conference rooms and have some medium size labs.</p>
+      <div>
+          <img alt="Universidad de Ciencias comerciales" src="${path}/static/images/logo_university.jpg" style="min-width: 16px; min-height: 16px; margin: 10px 0px; display: block; margin: 0 auto;" width="300"/>
+          </div>
+
       <h2>Useful info:</h2>
       <ul>
         <li><a class="external text" href="https://fedoraproject.org/wiki/FUDCon:Managua_2014#Accommodation">Accomodation</a></li>
diff --git a/fudcon.fedoraproject.org/static/images/logo_university.jpg b/fudcon.fedoraproject.org/static/images/logo_university.jpg
new file mode 100644
index 0000000000000000000000000000000000000000..e38d45b1766a4b38e3f9d28e6b7f93e91e00404d
GIT binary patch
-- 
1.9.3