>From 2d5f7e3ef82040c928e6d2b60d209ab15796bdb8 Mon Sep 17 00:00:00 2001
From: Jiri Tomasek <jtomasek@redhat.com>
Date: Tue, 24 Apr 2012 10:30:12 +0200
Subject: [PATCH conductor 2/4] changed simlinks, layout_helper is now
 unmodified, disabled most of the converge-ui
 stylesheets for now, reverted to conductor
 layout to prepare for incremental converge

---
 src/app/helpers/layout_helper.rb                   |    2 +-
 src/app/stylesheets/converge-ui.scss               |   15 ++--
 src/app/views/layouts/application.html.haml        |  114 ++++++++++---------
 .../views/layouts/converge-ui/_header_layout.haml  |    2 +-
 .../views/layouts/converge-ui/shell_layout.haml    |    2 +-
 5 files changed, 71 insertions(+), 64 deletions(-)

diff --git a/src/app/helpers/layout_helper.rb b/src/app/helpers/layout_helper.rb
index bb65d1e..b1e834e 120000
--- a/src/app/helpers/layout_helper.rb
+++ b/src/app/helpers/layout_helper.rb
@@ -1 +1 @@
-../../lib/converge-ui/rails/helpers/layout_helper.rb
\ No newline at end of file
+../../vendor/converge-ui/rails/helpers/layout_helper.rb
\ No newline at end of file
diff --git a/src/app/stylesheets/converge-ui.scss b/src/app/stylesheets/converge-ui.scss
index 7ba5dbe..6f21022 100644
--- a/src/app/stylesheets/converge-ui.scss
+++ b/src/app/stylesheets/converge-ui.scss
@@ -1,7 +1,8 @@
-@import "../../lib/converge-ui/stylesheets/footer.scss";
-@import "../../lib/converge-ui/stylesheets/forms.scss";
-@import "../../lib/converge-ui/stylesheets/header.scss";
-@import "../../lib/converge-ui/stylesheets/helpers.scss";
-@import "../../lib/converge-ui/stylesheets/media.scss";
-@import "../../lib/converge-ui/stylesheets/mixins.scss";
-@import "../../lib/converge-ui/stylesheets/shell.scss";
+@import "../../vendor/converge-ui/stylesheets/fonts.scss";
+//@import "../../vendor/converge-ui/stylesheets/footer.scss";
+//@import "../../vendor/converge-ui/stylesheets/forms.scss";
+//@import "../../vendor/converge-ui/stylesheets/header.scss";
+//@import "../../vendor/converge-ui/stylesheets/helpers.scss";
+//@import "../../vendor/converge-ui/stylesheets/media.scss";
+//@import "../../vendor/converge-ui/stylesheets/mixins.scss";
+//@import "../../vendor/converge-ui/stylesheets/shell.scss";
diff --git a/src/app/views/layouts/application.html.haml b/src/app/views/layouts/application.html.haml
index 1623356..c5b6625 100644
--- a/src/app/views/layouts/application.html.haml
+++ b/src/app/views/layouts/application.html.haml
@@ -1,59 +1,65 @@
-= content_for :title do
-  = t("layout.appname")
-  = "| #{@title}" unless @title.blank?
+!!! 5
+%html{"xml:lang" => "en", :lang => "en"}
+  %head
+    %meta{:charset => 'utf-8'}/
+    %title
+      = t("layout.appname")
+      = "| #{@title}" unless @title.blank?
+    %link{:rel =>  'shortcut icon', :href => '/favicon.ico'}
+    = stylesheet_link_tag '/stylesheets/reset.css'
+    = stylesheet_link_tag '/stylesheets/960.css'
+    = stylesheet_link_tag '/stylesheets/buttons.css'
+    = stylesheet_link_tag '/stylesheets/compiled/layout.css'
+    = stylesheet_link_tag 'jquery.ui-1.8.1/jquery-ui-1.8.1.custom.css'
+    = stylesheet_link_tag '/stylesheets/compiled/header.css'
+    /[if lt IE 9]
+      = javascript_include_tag 'http://html5shiv.googlecode.com/svn/trunk/html5.js'
+    /[if lt IE 8]
+      = stylesheet_link_tag '/stylesheets/layout_ie7.css'
 
-= content_for :stylesheets do
-  = stylesheet_link_tag '/stylesheets/reset.css'
-  = stylesheet_link_tag '/stylesheets/960.css'
-  = stylesheet_link_tag '/stylesheets/buttons.css'
-  = stylesheet_link_tag '/stylesheets/compiled/layout.css'
-  = stylesheet_link_tag 'jquery.ui-1.8.1/jquery-ui-1.8.1.custom.css'
-  = stylesheet_link_tag '/stylesheets/compiled/header.css'
-  = stylesheet_link_tag '/stylesheets/compiled/converge-ui.css'
-  /[if lt IE 9]
-    = javascript_include_tag 'http://html5shiv.googlecode.com/svn/trunk/html5.js'
-  /[if lt IE 8]
-    = stylesheet_link_tag '/stylesheets/layout_ie7.css'
+    :javascript
+      window.Conductor = {}
+      window.Conductor.PATH_PREFIX = "#{root_path}"
+      // This hack prevents Backbone from switching to the #/pools/1 type URLs
+      // when the browser doesn't support the HTML5 History API.
+      window.history || (window.history = {});
+      window.history.pushState || (window.history.pushState = function(){});
+      window.history.replaceState || (window.history.replaceState = function(){});
 
-  :javascript
-    window.Conductor = {}
-    window.Conductor.PATH_PREFIX = "#{root_path}"
-    // This hack prevents Backbone from switching to the #/pools/1 type URLs
-    // when the browser doesn't support the HTML5 History API.
-    window.history || (window.history = {});
-    window.history.pushState || (window.history.pushState = function(){});
-    window.history.replaceState || (window.history.replaceState = function(){});
+    = javascript_include_tag "jquery-1.6.1.min.js"
+    = javascript_include_tag "jquery.ui-1.8.1/jquery-ui-1.8.1.custom.min.js"
+    = javascript_include_tag "jquery.tmpl.min.js"
+    = javascript_include_tag "underscore-min.js"
+    = javascript_include_tag "backbone-min.js"
 
-  = javascript_include_tag "jquery-1.6.1.min.js"
-  = javascript_include_tag "jquery.ui-1.8.1/jquery-ui-1.8.1.custom.min.js"
-  = javascript_include_tag "jquery.tmpl.min.js"
-  = javascript_include_tag "underscore-min.js"
-  = javascript_include_tag "backbone-min.js"
+    = javascript_include_tag "application.js"
+    = javascript_include_tag "yetii-min.js"
 
-  = javascript_include_tag "application.js"
-  = javascript_include_tag "yetii-min.js"
+    = javascript_include_tag "backbone/models.js"
+    = javascript_include_tag "backbone/views.js"
+    = javascript_include_tag "backbone/routers.js"
+    = javascript_include_tag "rails.js"
+    = javascript_include_tag "lib/modernizr-custom.js"
+    = csrf_meta_tag
+    = yield :scripts
+  %body
+    %header.shell-design
+      %article
+        %h1
+          = t("layout.appname")
+        %nav#appnav
+          = render_navigation :level => 1
+        / Notifications and user dropdown -- disable notifications for now
+        %section#usermenu
+          %a{:href => '#'}= current_user.name
+          %ul
+            %li= link_to t('masthead.my_account'), account_path
+            %li= link_to t('masthead.logout'), logout_path
 
-  = javascript_include_tag "backbone/models.js"
-  = javascript_include_tag "backbone/views.js"
-  = javascript_include_tag "backbone/routers.js"
-  = javascript_include_tag "rails.js"
-  = javascript_include_tag "lib/modernizr-custom.js"
-
-= content_for :content do
-  .inner.container_16
-    = render :partial => '/layouts/new_notification' if flash.present? or content_for?(:error_messages)
-    = yield
-
-= content_for :logo do
-  = image_tag 'upstream-logo.png'
-
-= content_for :tabs do
-  = render_navigation :level => 1
-
-  %section#usermenu
-    %a{:href => '#'}= current_user.name
-    %ul
-      %li= link_to t('masthead.my_account'), account_path
-      %li= link_to t('masthead.logout'), logout_path
-
-= render :file => "layouts/converge-ui/shell_layout"
+    #content
+      = render :partial => '/layouts/new_notification' if flash.present? or content_for?(:error_messages)
+      = yield
+      .clear
+    %footer.standard
+      .container
+        %span.copyright!= t('layout.copyright')
diff --git a/src/app/views/layouts/converge-ui/_header_layout.haml b/src/app/views/layouts/converge-ui/_header_layout.haml
index 645857e..a322932 120000
--- a/src/app/views/layouts/converge-ui/_header_layout.haml
+++ b/src/app/views/layouts/converge-ui/_header_layout.haml
@@ -1 +1 @@
-../../../../lib/converge-ui/rails/layouts/_header_layout.haml
\ No newline at end of file
+../../../../vendor/converge-ui/rails/layouts/_header_layout.haml
\ No newline at end of file
diff --git a/src/app/views/layouts/converge-ui/shell_layout.haml b/src/app/views/layouts/converge-ui/shell_layout.haml
index 65f9026..84edcaf 120000
--- a/src/app/views/layouts/converge-ui/shell_layout.haml
+++ b/src/app/views/layouts/converge-ui/shell_layout.haml
@@ -1 +1 @@
-../../../../lib/converge-ui/rails/layouts/shell_layout.haml
\ No newline at end of file
+../../../../vendor/converge-ui/rails/layouts/shell_layout.haml
\ No newline at end of file
-- 
1.7.7.6